/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { MarkerSeries } from "./MarkerSeries";
import { Base, Type, runOn, Number_$type, enumGetBox, typeCast, Point_$type, fromEnum, markType } from "igniteui-react-core/ES5/type";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType_$type } from "igniteui-react-core/ES5/TrendLineType";
import { Brush } from "igniteui-react-core/ES5/Brush";
import { PenLineCap_$type } from "igniteui-react-core/ES5/PenLineCap";
import { DoubleCollection } from "igniteui-react-core/ES5/DoubleCollection";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { IFastItemsSource_$type } from "igniteui-react-core/ES5/IFastItemsSource";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-react-core/ES5/HashPool$2";
import { Clipper } from "igniteui-react-core/ES5/Clipper";
import { Dictionary$2 } from "igniteui-react-core/ES5/Dictionary$2";
import { OwnedPoint } from "./OwnedPoint";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
import { isNaN_, isInfinity } from "igniteui-react-core/ES5/number";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { GeometryGroup } from "igniteui-react-core/ES5/GeometryGroup";
import { stringIsNullOrEmpty } from "igniteui-react-core/ES5/string";
/**
 * @hidden
 */
var PolarBase = /** @class */ (function (_super) {
    tslib_1.__extends(PolarBase, _super);
    function PolarBase() {
        var _this = _super.call(this) || this;
        _this.m1 = null;
        _this.mu = null;
        _this.mz = null;
        _this.or = null;
        _this.oq = null;
        _this.m7 = null;
        _this.m9 = null;
        _this.na = null;
        _this.m4 = new PolarFrame();
        _this.m6 = new PolarFrame();
        _this.m3 = new PolarFrame();
        _this.my = null;
        _this.m5 = null;
        _this.m2 = null;
        _this.m5 = new PolarFrame();
        _this.m6.x = runOn(_this, _this.op);
        _this.m4.x = runOn(_this, _this.op);
        _this.m3.x = runOn(_this, _this.op);
        _this.m7 = new SeriesRenderer$2(PolarFrame.$, PolarBaseView.$, 0, runOn(_this, _this.n2), runOn(_this, _this.n4), runOn(_this, _this.ca), runOn(_this, _this.je), runOn(_this, _this.n0));
        return _this;
    }
    PolarBase.prototype.bf = function () {
        return new PolarBaseView(this);
    };
    PolarBase.prototype.im = function (a) {
        _super.prototype.im.call(this, a);
        this.m0 = a;
    };
    PolarBase.prototype.hn = function () {
        _super.prototype.hn.call(this);
        this.mw = null;
        this.mx = null;
    };
    PolarBase.prototype.get_c0 = function () {
        return true;
    };
    PolarBase.prototype.ng = function (a) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var b = this.mw;
        var c = new ScalerParams(1, this.bs.mq, this.lr, b.b8);
        c.c = this.getEffectiveViewport1(this.bi);
        var d = this.mx;
        var e = new ScalerParams(1, this.bs.mq, this.lr, d.b8);
        e.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.lt.cc(function (f) {
            if (f._visibility == 0) {
                var g = new SeriesPointOfInterest();
                var h = f.n;
                var i = f.o;
                if (h < _this.lr.left || h > _this.lr.right || i < _this.lr.top || i > _this.lr.bottom) {
                    return;
                }
                g.b = b.dw(h, c);
                g.c = d.dw(i, e);
                g.a = f.content;
                a.add(g);
            }
        });
        return true;
    };
    PolarBase.prototype.n0 = function () {
        if (this.bt.g) {
            this.bt.t();
        }
    };
    PolarBase.prototype.n1 = function () {
        this.my.e(this.m1.w, this.nb, this.nc, this.or, this.oq, function (a, b) { return Math.cos(b); }, function (a, b) { return Math.sin(b); }, true);
    };
    Object.defineProperty(PolarBase.prototype, "nb", {
        get: function () {
            return this.m9;
        },
        set: function (a) {
            if (this.m9 != a) {
                var b = this.nb;
                this.m9 = a;
                this.raisePropertyChanged("AngleColumn", b, this.nb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "nc", {
        get: function () {
            return this.na;
        },
        set: function (a) {
            if (this.na != a) {
                var b = this.nc;
                this.na = a;
                this.raisePropertyChanged("RadiusColumn", b, this.nc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "ok", {
        get: function () {
            return this.c(PolarBase.n5);
        },
        set: function (a) {
            this.h(PolarBase.n5, a);
        },
        enumerable: true,
        configurable: true
    });
    PolarBase.prototype.h4 = function () {
        _super.prototype.h4.call(this);
        if (this.mx != null) {
            this.mx.g0(false);
        }
        if (this.mw != null) {
            this.mw.g0(false);
        }
    };
    PolarBase.prototype.hs = function (a, b, c, d) {
        var e = false;
        this.m0.cr.g$e(a, b, c, d);
        if (this.mw != null && !this.mw.ck()) {
            e = true;
        }
        if (this.mx != null && !this.mx.ck()) {
            e = true;
        }
        if (e) {
            this.i6(true);
        }
    };
    PolarBase.prototype.jl = function (a, b) {
        this.i6(false);
    };
    PolarBase.prototype.jm = function (a, b) {
        this.i6(false);
    };
    PolarBase.prototype.dv = function (a, b, c) {
        var d = true;
        if (!_super.prototype.dv.call(this, a, b, c) || !c.l() || b.isEmpty || a.isEmpty || this.mw == null || this.mx == null || this.nb == null || this.nc == null || this.nb.count == 0 || this.nc.count == 0 || this.bz == null || this.bz.count != this.nb.count || this.bz.count != this.nc.count || this.my == null || this.mw.bf == null || this.mx.bf == null || this.mw.jx == this.mw.jw || this.mx.jx == this.mx.jw) {
            d = false;
        }
        return d;
    };
    PolarBase.prototype.i7 = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.dv(c, b, this.bi)) {
            this.hp(true, this.bi);
            return;
        }
        this.or = b;
        this.oq = c;
        this.mz = new PolarAxisInfoCache(this.mw, this.mx, this.bz);
        var e = new SeriesRenderingArguments(this, c, b, a, this.dd);
        var f = this.m7.g(e, this.m4, this.m3, this.m6, this.m0);
        this.m4 = f.p1;
        this.m3 = f.p2;
        this.m6 = f.p3;
    };
    PolarBase.prototype.op = function (a) {
        var b = this.my.h(a.x, a.y, this.or, this.oq, this.mz.e, this.mz.d, this.mz.g, this.mz.f, this.mz.i, this.mz.h);
        return b;
    };
    PolarBase.prototype.an = function (a) {
        if (a != null && a == this.mw && this.nb != null) {
            return new AxisRange(this.nb.minimum, this.nb.maximum);
        }
        if (a != null && a == this.mx && this.nc != null) {
            return new AxisRange(this.nc.minimum, this.nc.maximum);
        }
        return null;
    };
    PolarBase.prototype.c8 = function (a) {
        var b = this.bi.bs;
        b = b.copy();
        var c = this.bi.br;
        var d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.mw == null || this.nb == null || this.mx == null || this.nc == null) {
            return false;
        }
        if (d < 0 || d > this.nb.count - 1 || d > this.nc.count - 1) {
            return false;
        }
        var e = this.mw.getScaledAngle(this.nb.item(d));
        var f = this.mx.li(this.nc.item(d));
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    };
    PolarBase.prototype.fm = function (a) {
        return null;
    };
    PolarBase.prototype.e5 = function (a) {
        return -1;
    };
    PolarBase.prototype.ag = function () {
        return [this.mw, this.mx];
    };
    PolarBase.prototype.is = function (a, b, c, d) {
        _super.prototype.is.call(this, a, b, c, d);
        if (this.m0.cr.g$b(a, b, c, d)) {
            this.i6(false);
            this.ic();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.nb);
                    c.deregisterColumn(this.nc);
                    this.nb = null;
                    this.nc = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.nb = this.bw(this.np);
                    this.nc = this.bw(this.nv);
                }
                if ((this.mx != null && !this.mx.ck()) || (this.mw != null && !this.mw.ck())) {
                    this.i6(false);
                }
                break;
            case PolarBase.$$p[0]:
                if (this.mw != null && this.mx != null) {
                    this.my = new PolarAxes(this.mx, this.mw);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                if (this.mw != null && !this.mw.ck()) {
                    this.i6(false);
                }
                else if (c != null && d == null) {
                    this.hp(true, this.bi);
                }
                break;
            case PolarBase.$$p[4]:
                if (this.mw != null && this.mx != null) {
                    this.my = new PolarAxes(this.mx, this.mw);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                if (this.mx != null && !this.mx.ck()) {
                    this.i6(false);
                }
                else if (c != null && d == null) {
                    this.hp(true, this.bi);
                }
                if (this.mw != null && !this.mw.ck()) {
                    this.mw.gw();
                }
                break;
            case PolarBase.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nb);
                    this.nb = this.bw(this.np);
                }
                break;
            case "AngleColumn":
                this.m0.cr.g$i();
                if (this.mw != null && !this.mw.ck()) {
                    this.i6(false);
                }
                break;
            case PolarBase.$$p[5]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nc);
                    this.nc = this.bw(this.nv);
                }
                break;
            case "RadiusColumn":
                this.m0.cr.g$i();
                if (this.mx != null && !this.mx.ck()) {
                    this.i6(false);
                }
                break;
            case PolarBase.$$p[6]:
                this.i6(false);
                this.ic();
                break;
            case PolarBase.$$p[3]:
                this.i6(false);
                this.ic();
                break;
            case "TransitionProgress":
                this.mz = new PolarAxisInfoCache(this.mw, this.mx, this.bz);
                this.or = this.bi.bs;
                this.oq = this.bi.br;
                this.m6.v = this.nh;
                this.m6.c(this.ew, this.m4, this.m3);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ew == 1) {
                    this.n4(this.m3, this.m0);
                }
                else {
                    this.n4(this.m6, this.m0);
                }
                if (this.bs != null) {
                    this.bs.jj(this);
                }
                break;
            case "TrendLineBrush":
                this.jh();
                break;
            case PolarBase.$$p[2]:
                this.i6(false);
                this.ic();
                break;
            case "TrendLineType":
                this.ic();
                break;
        }
    };
    PolarBase.prototype.ne = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.nd = function (a) {
        if (typeCast(NumericAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.hp = function (a, b) {
        _super.prototype.hp.call(this, a, b);
        var c = b;
        if (a) {
            c.cs.clear();
        }
        c.cr.g$d();
    };
    PolarBase.prototype.mv = function (a, b) {
        var c = a.top - 10;
        var d = a.bottom + 10;
        var e = a.left - 10;
        var f = a.right + 10;
        var g = ((function () {
            var $ret = new Clipper(1, e, d, f, c, false);
            $ret.i = b;
            return $ret;
        })());
        return g;
    };
    PolarBase.prototype.nz = function (a, b, c, d) {
        a.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, b);
        var e = this.bz;
        var _loop_1 = function (f) {
            var g = a.w._inner[f];
            if (!isInfinity(g.x) && !isInfinity(g.y)) {
                var h_1 = { $type: Point_$type, x: this_1.nb.item(f), y: this_1.nc.item(f) };
                var i_1 = { $type: Point_$type, x: g.x, y: g.y };
                a.g.addItem(e.item(f), ((function () {
                    var $ret = new OwnedPoint();
                    $ret.a = e.item(f);
                    $ret.b = h_1;
                    $ret.c = i_1;
                    return $ret;
                })()));
            }
        };
        var this_1 = this;
        for (var f = 0; f < b; f++) {
            _loop_1(f);
        }
    };
    PolarBase.prototype.n2 = function (a, b) {
        var _this = this;
        var c = b.bs;
        var d = b.br;
        a.j.clear();
        a.n.clear();
        var e = Math.min(this.nb != null ? this.nb.count : 0, this.nc != null ? this.nc.count : 0);
        if (e < 1) {
            return;
        }
        this.mz = new PolarAxisInfoCache(this.mw, this.mx, this.bz);
        this.m1 = a;
        this.oq = d;
        this.or = c;
        b.cp.l(a.j, this.nk, c, d, this.er);
        if (e <= this.nk) {
            this.nz(a, e, c, d);
        }
        var f = this.mv(d, a.n);
        var g = Math.min(this.mw.jx, this.mw.jw);
        var h = Math.max(this.mw.jw, this.mw.jx);
        b.cr.q = this.nh;
        b.cr.p = 0;
        b.cr.s = this.mx.lc;
        b.cr.r = this.mx.lb;
        b.cr.t = function (i, j) { return _this.my.c(i, j, c, d, Math.cos); };
        b.cr.u = function (i, j) { return _this.my.d(i, j, c, d, Math.sin); };
        var i = new List$1(Number_$type, 0);
        for (var j = 0; j < this.nb.count; j++) {
            if (this.nb.item(j) >= g && this.nb.item(j) <= h) {
                i.add(this.nb.item(j));
            }
        }
        var k = this.nc;
        if (i.count != this.nb.count) {
            k = new List$1(Number_$type, 0);
            for (var l = 0; l < this.nb.count; l++) {
                if (this.nb.item(l) >= g && this.nb.item(l) <= h) {
                    k.add(this.nc.item(l));
                }
            }
        }
        b.cr.v(a.n, this.m8, i, k, this.nl, runOn(this.mw, this.mw.getScaledAngle), runOn(this.mx, this.mx.li), ((function () {
            var $ret = new TrendResolutionParams();
            $ret.b = _this.er;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })()), f, g, h);
    };
    PolarBase.prototype.n4 = function (a, b) {
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.lj(b);
        this.mz = new PolarAxisInfoCache(this.mw, this.mx, this.bz);
        b.cp.j(a.j, this.ly);
        b.cj();
        var g = this.mv(d, b.cr.g$j.aj);
        b.cr.g$h(a.n, g);
        this.ny(d, c, e, f, b);
    };
    PolarBase.prototype.ny = function (a, b, c, d, e) {
        e.cu(a, b, c, d);
    };
    PolarBase.prototype.jh = function () {
        _super.prototype.jh.call(this);
        if (this.fe < 0) {
            return;
        }
        this.m0.cw();
    };
    PolarBase.prototype.i8 = function (a, b) {
        _super.prototype.i8.call(this, a, b);
        if (!this.dk) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        var c = this.bh;
        if (!this.de) {
            this.m5 = new PolarFrame();
            this.n2(this.m5, c);
        }
        this.de = false;
        this.n4(this.m5, c);
        this.dk = false;
    };
    PolarBase.prototype.i5 = function (a, b, c, d, e) {
        _super.prototype.i5.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.m2 == null) {
            this.m2 = new PolarFrame();
        }
        this.n2(this.m2, g);
        this.n4(this.m2, g);
    };
    PolarBase.prototype.n3 = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = tslib_1.__values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var _e = tslib_1.__values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.g(e);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    PolarBase.prototype.mt = function (a, b, c) {
        this.n1();
        return this.m1.w.toArray();
    };
    PolarBase.prototype.ni = function (a) {
        var e_3, _a;
        var b = new List$1(Number_$type, 0);
        var c = this.bz;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.m0.cs.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                b.add(c.indexOf(d));
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return b;
    };
    PolarBase.prototype.oo = function (a) {
        return { $type: Point_$type, x: this.nb.item(a), y: this.nc.item(a) };
    };
    PolarBase.prototype.hy = function (a) {
        _super.prototype.hy.call(this, a);
        this.a2.exportTrendlineData(this, a, this.m0.cr.g$j);
    };
    PolarBase.$t = markType(PolarBase, 'PolarBase', MarkerSeries.$);
    PolarBase.n5 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, PolarBase.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    return PolarBase;
}(MarkerSeries));
export { PolarBase };
Type.dep(DependencyProperty, PropertyMetadata, PolarBase, 'raisePropertyChanged', ['AngleAxis:mw:n6', [NumericAngleAxis.$, null], 'AngleMemberPath:np:n7', [2], 'ClipSeriesToBounds:nf:n8', [0, false], 'MaximumMarkers:nk:n9', [1, 400], 'RadiusAxis:mx:oa', [NumericRadiusAxis.$, null], 'RadiusMemberPath:nv:ob', [2], 'UseCartesianInterpolation:nh:oj', [0, true], 'TrendLineType:m8:oh', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:nj:og', [1, 1.5], 'TrendLinePeriod:nl:of', [1, 7], 'TrendLineZIndex:nm:oi', [1, 1], 'TrendLineBrush:ol:oc', [Brush.$, null], 'TrendLineDashArray:om:od', [DoubleCollection.$], 'TrendLineDashCap:on:oe', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
var PolarBaseView = /** @class */ (function (_super) {
    tslib_1.__extends(PolarBaseView, _super);
    function PolarBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cq = null;
        _this.cp = null;
        _this.cr = null;
        _this.cs = null;
        _this.cq = a;
        _this.cs = new HashPool$2(Base.$, Marker.$);
        _this.ce(_this.cs);
        _this.cr = new PolarTrendLineManager();
        return _this;
    }
    PolarBaseView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.cp = this.co();
        if (!this.n) {
            this.cq.nk = 1000;
            this.by.lu = 2;
        }
    };
    PolarBaseView.prototype.co = function () {
        var _this = this;
        var a = new NumericMarkerManager(0, function (b) { return _this.cs.item(b); }, function (b) { return _this.cq.mz.c.item(b); }, runOn(this, this.cv), runOn(this, this.cn), runOn(this, this.ct));
        a.n = true;
        a.p = runOn(this.cq, this.cq.oo);
        return a;
    };
    PolarBaseView.prototype.cv = function (a) {
        this.cq.n3(a, this.cs);
    };
    PolarBaseView.prototype.cn = function () {
        return this.cq.mt(this.cs, this.bs, this.br);
    };
    PolarBaseView.prototype.ct = function () {
        return this.cq.ni(this.cs);
    };
    PolarBaseView.prototype.cu = function (a, b, c, d) {
        if (this.cq.nf) {
            var e = new GeometryGroup();
            this.cq.mx.lq(e, a, b, c, d);
        }
        else {
        }
    };
    PolarBaseView.prototype.cw = function () {
        if (this.cq.ol != null) {
            this.cq.ok = this.cq.ol;
        }
        else {
            this.cq.ok = this.cq.kw;
        }
    };
    PolarBaseView.prototype.cc = function (a) {
        this.cs.f(a);
    };
    PolarBaseView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.cq.m8 != 0 && !b) {
                var c = this.cr.g$j;
                c.ac = this.cq.nj;
                c._stroke = this.cq.ok;
                c.ad = this.cq.on;
                c.ai = this.cq.om;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    PolarBaseView.prototype.cx = function () {
        return Rect.empty;
    };
    PolarBaseView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span>" + "${item." + this.cq.np + "}" + "</span><br/><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cq.fs + ": </span><span class='ui-priority-primary'>" + "${item." + this.cq.nv + "}</span></div>";
        return a;
    };
    PolarBaseView.$t = markType(PolarBaseView, 'PolarBaseView', MarkerSeriesView.$);
    return PolarBaseView;
}(MarkerSeriesView));
export { PolarBaseView };
